/* URLs */
var g_QuoteHostname = "http://activequote.fidelity.com";
var g_NewsHostname = "http://news-mobi.fidelity.com";
var g_UpdateUrl = "http://www.fidelitylabs.com/mac/widgetupdate.xml";
var g_CookieUrl = "http://personal.fidelity.com/misc/labs/webstats.xml";
var g_ResearchUrl = "http://eresearch.fidelity.com";
var g_ChartUrl = "http://chartbigchart.gtm.idmanagedsolutions.com";
var g_HomeUrl = "https://www.fidelity.com";
var g_TermsUrl = "http://personal.fidelity.com";
var g_HelpDateTimeUrl = "https://scs.fidelity.com";

var DEFAULT_PORTFOLIO_SYMBOLS = ".DJI,.IXIC,.SPX";
/* See debug function for details */
var DEBUG = false;

var version = 1.4;
var portfolio = [];
var theSymbols = [];
var fullNames = [];
var values = [];
var pointChanges = [];
var directions = [];
var percentChanges = [];
var deleteButtons = [];
var backgroundImages = [];
var backgroundOffsets = [];
var sortArray;
var sortOrder = "pctChgDesc";
var oldCount = 0;
var panelPref;
var isMinimized = false;
var chosenTab = "";
var isMoving = false;
var moveFunction;
var panel_open_right = document.getElementById('panel_open-right');
var positionY = 280;
var pollInterval = 600;
var quoteInterval;
var detailsInterval;
var chartsInterval;
var newsInterval;
var mouseOver = -1;
var allowPref;

/*--------SymbolSearch-------------*/
var stockNames = [];
var stockSymbols = [];
var stockAdd = [];
var theStockSymbols = [];
var theStockNames = [];

/*--------tabs----------------------*/
var tabsOpen = false;
var chosenSymbol;
var chosenItem;
var newsHeadlineTextArray = [];
var newsSourceTextArray = [];
var newsDateTimeTextArray = [];
var newsSpaceTextArray = [];
var newsMoreTextArray = [];
var newsErrorTextArray = [];


var theDetailsHeaders = [];
var theDetailsHeadersShadow = [];
var theDetails = [];
var theDetailsShadow = [];
var securityTypeValue;
var detailsArray = [];
var detailsHeadersArray = [];

var newsErrorText;
var updateVersion;
var updateMandatory;
var updateMessage;
var updateUrl;
var genericErrMsg = "Fidelity is unable to provide the information that you requested at this time Please retry your request at a later time.";


var scrollbar, scrollArea;
var Results_data_scrollbar, Results_data_scrollArea;
var news_scrollbar, news_scrollArea;
var isInResizeMode = false;
var showTabsDone = true;

/**
 * Writes msg to console if DEBUG is true.
 */
function debug(msg){
	if(DEBUG){
		alert("DEBUG: " + msg);
	}
}

function loaded()
{
	debug("loaded() start");
    window.resizeTo(840, 357);
    checkUpdate();
    widget.setCloseBoxOffset(270,0);
    setTimeout('setAddSymbolFocus();',500);

    if (window.widget && widget) 
    {
		panelPref = widget.preferenceForKey ("panelPreference");
		if (!(panelPref && panelPref > 0))
		{
			panelPref = 0;
		}
		if(panelPref == 0) 
		{
	    	document.getElementById('pref_radio1').checked=true;
		}
		else
		{
	    	document.getElementById('pref_radio2').checked=true;
		}
		widget.setPreferenceForKey(panelPref,"panelPreference");
    }

    Results_data_scrollbar = new AppleVerticalScrollbar(document.getElementById("searchScrollBar"));
    Results_data_scrollArea = new AppleScrollArea(document.getElementById("Results_data_container"), Results_data_scrollbar);
    Results_data_scrollArea.scrollsHorizontally = false;
    Results_data_scrollArea.singlepressScrollPixels = 25;
    Results_data_scrollbar.setAutohide(true);

    news_scrollbar = new AppleVerticalScrollbar(document.getElementById("newsScrollBar"));
    news_scrollArea = new AppleScrollArea(document.getElementById("news_container"), news_scrollbar);
    news_scrollArea.scrollsHorizontally = false;
    news_scrollArea.singlepressScrollPixels = 25;
    news_scrollbar.setAutohide(true);

    scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
    scrollArea = new AppleScrollArea(document.getElementById("container"), scrollbar);
    scrollArea.scrollsHorizontally = false;
    scrollArea.singlepressScrollPixels = 25;
    scrollArea.focus();
    
    // for key control when first loading in Safari
    window.onfocus = function(){
		scrollArea.focus();
		scrollArea.reveal(document.getElementById('contents'));
		scrollArea.refresh();
    };
    
    window.onblur = function(){ 
    	scrollArea.blur(); 
    };

    scrollbar.setAutohide(false);

    getQuotes();
    scrollArea.reveal(document.getElementById('contents'));
    scrollArea.refresh();
    
    if(event){
    	event.stopPropagation();
    	event.preventDefault();
    }
}

function checkAllow()
{
    if (window.widget && widget) {
		allowPref = widget.preferenceForKey ("allowPreference");
		if (!(allowPref && allowPref > 0))
		{
			allowPref = 0;
		}
		if(allowPref == 0) 
		{
			document.getElementById('Fidelity_MarketMonitor_Allow').style.display= "block";
			document.getElementById('main').style.display= "none";
		}
		else
		{
			document.getElementById('Fidelity_MarketMonitor_Allow').style.display= "none";
			document.getElementById('main').style.display= "block";
		}
		widget.setPreferenceForKey(allowPref,"allowPreference");
	}
}

function allow()
{
    widget.setPreferenceForKey(1,"allowPreference");
    document.getElementById('Fidelity_MarketMonitor_Allow').style.display= "none";
    document.getElementById('main').style.display= "block";
}

function deny()
{
    widget.setPreferenceForKey(0,"allowPreference");
    document.getElementById('Fidelity_MarketMonitor_Allow').style.display= "none";
    document.getElementById('main').style.display= "none";
}

function findChild (element, nodeName)
{
	var child;

	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
		{
			return child;
		}
	}

	return null;
}

function getNodeValue (node)
{
    var nodeValue = "";
    if (node != null)
    {
		try{
			nodeValue = node.item(0).firstChild.data;
		}
		catch(e){
			nodeValue = "";
		}
    }
    return nodeValue;
}

function setSortOrder(sortOrderValue)
{
    var sortOrderValueDesc = sortOrderValue + "Desc";
    cleanArrows();
    if (sortOrder == sortOrderValueDesc)
    {
		sortOrder = sortOrderValue + "Asc";
		var sortAscending = sortOrderValue + "_sort_ascending";
		var sortAscendingElement = document.getElementById(sortAscending);
		sortAscendingElement.style.display = "block"
    }
    else
    {
		sortOrder = sortOrderValueDesc;
		var sortDescending = sortOrderValue + "_sort_descending";
		var sortDescendingElement = document.getElementById(sortDescending);
		sortDescendingElement.style.display = "block"
    }
    updateBoard();

}

function cleanArrows()
{
    document.getElementById("Symbol_sort_ascending").style.display = "none";
    document.getElementById("Symbol_sort_descending").style.display = "none";
    document.getElementById("Price_sort_ascending").style.display = "none";
    document.getElementById("Price_sort_descending").style.display = "none";
    document.getElementById("Chg_sort_ascending").style.display = "none";
    document.getElementById("Chg_sort_descending").style.display = "none";
    document.getElementById("pctChg_sort_ascending").style.display = "none";
    document.getElementById("pctChg_sort_descending").style.display = "none";
}


function deleteItem(item)
{
    var stockList = new Array();
    sortArray.splice(item, 1);
    for (var i=0; i < sortArray.length; i++)
    {
        stockList[i] = sortArray[i][0]
    }
    if (stockList == "")
    {
        widget.setPreferenceForKey("EMPTY","userSymbols");
        buildBoard(0);
        updateBoard();
    }
    else
    {
        var newStockList = stockList.join(",");
        widget.setPreferenceForKey(newStockList,"userSymbols");
        buildBoard(stockList.length);
        updateBoard();
    }
    
    getQuotes();

}

function symbolKeyPress (event,primaryPart)
{
    switch (event.keyCode)
    {
        case 13: // return
        case 3:	 // enter
        writePrefs( primaryPart );
    }
}

function setAddSymbolFocus()
{
    document.getElementById("Add_symbol").focus();
    document.getElementById("Add_symbol").select();
    document.getElementById("Add_symbol").value = "";
}

function ValidateInput(sInputString)
{
    if ((sInputString.indexOf("*")!=-1) || (sInputString.indexOf("<")!=-1) || (sInputString.indexOf(">")!=-1) ||(sInputString.indexOf("(")!=-1) ||(sInputString.indexOf(")")!=-1) ||(sInputString.indexOf(";")!=-1) ||(sInputString.indexOf('"')!=-1) ||(sInputString.indexOf("'")!=-1) ||(sInputString.indexOf("+")!=-1) ||(sInputString.indexOf("%")!=-1) || (sInputString.length > 50))
    {
		return false;
    }
    return true;
}

function duplicateCheck(checkSymbol)
{
    var myList;
    if (window.widget && widget) 
    {
		myList = widget.preferenceForKey ("userSymbols");
    }

    myList = myList.toUpperCase().split(",");

    for (item in myList)
    {
		if ( myList[item] == checkSymbol.toUpperCase() )
		{
			displayMessage("The symbol " + checkSymbol + " is already in your list.");
			debug("The symbol " + checkSymbol + " is already in your list.");
			document.getElementById("Add_symbol").focus();
			return true;
		}
    }
    return false;
}



function displayMessage (msgString)
{
    var menu = null;
    if (window.widget)
    {
    	menu = widget.createMenu();
    }
    if (menu != null)
    {
		menu.addMenuItem (msgString);
		menu.setMenuItemEnabledAtIndex (0, false);
		menu.popup (278, 70);
    }
}

function displayGenericMsg ()
{
    var menu = null;
    if (window.widget) menu = widget.createMenu();
    var msgArray = ["Fidelity is unable to provide the information that you requested at this time.","This may be due to scheduled system maintenance or an intermittent outage.","Please retry your request at a later time."];
    if (menu != null)
    {
		for (var i = 0; i < 3; ++i)
		{
			menu.addMenuItem (msgArray[i]);
			menu.setMenuItemEnabledAtIndex (i, false);
		}
		var menuitem = menu.popup (278, 70);
    }
}

function writePrefs( primaryPart )
{
    setTimeout('setAddSymbolFocus();',0);
    portfolio = widget.preferenceForKey ("userSymbols").split(",");
    debug("writePrefs: portfolio.length=" + portfolio.length);
    if (portfolio.length > 24)
    {
		displayMessage("you can only have up to 25 symbols in your list");
		debug("writePrefs: you can only have up to 25 symbols in your list");
		return false;
    }
    if (primaryPart == "") 
    {
    	return;
    }
    while (primaryPart.substring(0,1) == ' ')
    {
    	primaryPart = primaryPart.substring(1);
    }
    while (primaryPart.substring(primaryPart.length-1,primaryPart.length) == ' ') 
    {
    	primaryPart = primaryPart.substring(0,primaryPart.length-1);
    }
    primaryPart = primaryPart.replace(/\r|\n/,"");
    if (ValidateInput(primaryPart) == false)
    {
		document.getElementById("Add_symbol").focus();
		displayMessage ("Invalid Symbol: " + primaryPart);
		debug("writePrefs: Invalid Symbol:	 " + primaryPart);
		return;
    }

    debug("writePrefs: primaryPart	" + primaryPart);
    var now = new Date();
    var url = g_QuoteHostname + "/service/quote/lite?productid=widget&version=1.0&symbols=" + primaryPart + "&ts=" + now.getTime();
    debug("url="+ url);
    var xml_request = new XMLHttpRequest();
    xml_request.onload = function(e) {
    	quoteCheck(e, xml_request,primaryPart);
    };
    xml_request.overrideMimeType("text/xml");
    xml_request.open("GET", url);
    xml_request.setRequestHeader("Cache-Control", "no-cache");
    xml_request.send(null);

}

function quoteCheck( event, request,primaryPart)
{
    var doc;
    var resultsNode;
    var err;
    var portfolioSymbols;

    if (!request.responseXML)
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

    try
    {
		doc = request.responseXML;
		resultsNode =doc.getElementsByTagName("MarketData");
		if (resultsNode.length < 1)
		{
			displayGenericMsg();
			debug(genericErrMsg);
			return 0;
		}
    }
    catch( e )
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

    try
    {
		doc = request.responseXML;
		resultsNode =doc.getElementsByTagName("Q");
		err = resultsNode.item(0).getAttribute("err");
		debug(err);
    }
    catch( e )
    {
		displayMessage ("Invalid Symbol: " + primaryPart)
		debug("Invalid Symbol: " + primaryPart);
		connected = false;
		return 0;
    }
    if (err!= "0")
    {
		displayMessage ("Invalid Symbol: " + primaryPart)
		debug("Invalid Symbol: " + primaryPart);
		return 0;
    }


	if ( primaryPart != null )
	{
		if ( duplicateCheck( primaryPart) )
		{
			return;
		}
		portfolioSymbols = widget.preferenceForKey ("userSymbols");
		if (portfolioSymbols == "EMPTY")
		{
			portfolioSymbols = primaryPart;
		}
		else{
			portfolioSymbols = portfolioSymbols + "," + primaryPart;
		}
		portfolioSymbols = portfolioSymbols.replace(" ","");
		widget.setPreferenceForKey(portfolioSymbols,"userSymbols")
	
		getQuotes();
	
	}

}


function getQuotes()
{

    if(theSymbols != null){
        for(var n=0; n < theSymbols.length; n++ )
	    {
            theSymbols[n].style.opacity = .25;
            values[n].style.opacity = .25;
            if (isMinimized == false)
            {
                pointChanges[n].style.opacity = .25;
                percentChanges[n].style.opacity = .25;
            }
            if (panelPref == 1)
            {
                directions[n].style.opacity = .25;
            }
        }
    }

    var portfolioSymbols = "";
    if (window.widget && widget) 
    {
        portfolioSymbols = widget.preferenceForKey ("userSymbols");
        if (!portfolioSymbols || portfolioSymbols == 'EMPTY') {
            portfolioSymbols = DEFAULT_PORTFOLIO_SYMBOLS;
            widget.setPreferenceForKey(portfolioSymbols,"userSymbols");
        }
    }
    portfolioSymbols = portfolioSymbols.replace(/\r|\n/,"");
    portfolioSymbols = portfolioSymbols.replace(" ","");
    symbolList = portfolioSymbols;
    portfolio = portfolioSymbols.split(",");

	var now = new Date();
    var url = g_QuoteHostname + "/service/quote/lite?productid=widget&version=1.0&symbols=";
    url = url + symbolList + "&ts="+now.getTime();
    debug("url="+url);
    var xml_request = new XMLHttpRequest();
    xml_request.onload = function(e) {quoteReceived(e, xml_request);}
    xml_request.overrideMimeType("text/xml");
    xml_request.open("GET", url);
    xml_request.setRequestHeader("Cache-Control", "no-cache");
    xml_request.send(null);
}


function quoteReceived( event, request)
{
    sortArray = new Array();
    var doc;
    var resultsNode;

    if (!request.responseXML)
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

    try
    {
		doc = request.responseXML;
		resultsNode =doc.getElementsByTagName("Q");
    }
    catch( e )
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

    pollInterval = doc.getElementsByTagName("UPDATE");
    if (pollInterval.length ==	0)
    {
		displayGenericMsg();
		return;
    }
    pollIntervalValue = pollInterval.item(0).firstChild.nodeValue;
    pollIntervalValue = pollIntervalValue * 1000;
    clearInterval(quoteInterval)
    quoteInterval = setInterval('getQuotes();', pollIntervalValue);
    quoteCount = 0;

    var symbolValue;
    var nameValue;
    var lasttradeValue;
    var changeValue;
    var pctchangeValue;
    var dateValue;
    var timeValue;

    if (resultsNode == null)
    {
		displayMessage ("There was a problem parsing search results.")
		debug("There was a problem parsing search results.");
		return;
    }
    else
    {
		for (n = 0; n < resultsNode.length; n++)
		{
			var node = resultsNode.item(n);
			try{
				symbolValue = node.getAttribute("s");
			}
			catch(e){
				symbolValue = "N/A";
			}
			
			try{
				lasttradeValue = node.getAttribute("lp");
				if(lasttradeValue == null)
				{ 
					lasttradeValue = node.getAttribute("npc");
				}
				if(lasttradeValue == null)
				{ 
					lasttradeValue = node.getAttribute("pc");
				}
				lasttradeValue = lasttradeValue.replace(",","");
			}
			catch(e){
				lasttradeValue = 0;
			
			}
			try{
				changeValue = node.getAttribute("nt");
				if(changeValue == null)
				{
					changeValue = node.getAttribute("lc");
				}
				if(changeValue == null)
				{
					changeValue = node.getAttribute("nnc");
				}
				changeValue = changeValue.replace(",","");
			}
			catch(e)
			{
				changeValue = 0;
			}
			
			try
			{
				pctchangeValue= node.getAttribute("lpc");
				if(pctchangeValue == null) 
				{
					pctchangeValue=node.getAttribute("pct");
				}
				if(pctchangeValue == null)
				{
					pctchangeValue=node.getAttribute("PCT");
				}
			}
			catch(e)
			{
				pctchangeValue = 0;
			}
			
			try
			{
				nameValue = node.getAttribute("n");
				if(nameValue == null) 
				{
					nameValue =node.getAttribute("na");
				}
				nameValue = nameValue.replace('&#38;','&');
			}
			catch(e){
				nameValue = "N/A";
			}
			
			try{
				dateValue = node.getAttribute("ad");
				if(dateValue == null)
				{
					dateValue = node.getAttribute("ld");
				}
				if(dateValue == null)
				{
					dateValue = node.getAttribute("nd");
				}
				if(dateValue == null)
				{
					dateValue = node.getAttribute("ndd")
				};
			}
			catch(e){
				dateValue = "";
			}
			
			try{
				timeValue = node.getAttribute("lt");
				if(timeValue == null)
				{
					timeValue = "";
				}
			}
			catch(e){
				timeValue = "";
			}
	
			sortArray[n] = new Array();
			sortArray[n][0] = symbolValue;
			sortArray[n][1] = lasttradeValue;
			sortArray[n][2] = changeValue;
			sortArray[n][3] = pctchangeValue;
			sortArray[n][4] = nameValue;
			sortArray[n][5] = dateValue;
			sortArray[n][6] = timeValue;
			quoteCount++;
		}
	}

	buildBoard( quoteCount );
	updateBoard();
	return quoteCount;
}

function removeAllChildren (parent)
{
	while (parent.hasChildNodes())
	{
		parent.removeChild(parent.firstChild);
	}
}


function buildBoard(count)
{
    var horizOffset = 0;
    var symbolCount = 0;
    var itemCount = 0;
    var container = document.getElementById('contents');

    if (count == 0)
    {
        while ( theSymbols.length > 0 )
        {
            item = theSymbols.pop(); 
            item.style.display = "none"; 
            delete item;
            item = values.pop(); 
            item.style.display = "none"; 
            delete item;
            item = pointChanges.pop(); 
            item.style.display = "none"; 
            delete item;
            item = directions.pop(); 
            item.style.display = "none"; 
            delete item;
            item = percentChanges.pop(); 
            item.style.display = "none"; 
            delete item;
            item = backgroundImages.pop(); 
            item.style.display = "none"; 
            delete item;
            item = deleteButtons.pop();  
            item.style.display = "none"; 
            delete item;
        }

        oldCount = 0;
        return;
    }
    else if (count == oldCount)
    {
        return;
    }
    else if (count > oldCount)
    {
        symbolCount = oldCount;
    }
    else
    {
        symbolCount = count;
        while ( theSymbols.length > symbolCount )
        {
            item = theSymbols.pop(); 
            item.style.display = "none"; 
            delete item;
            item = values.pop(); 
            item.style.display = "none"; 
            delete item;
            item = pointChanges.pop(); 
            item.style.display = "none"; 
            delete item;
            item = directions.pop(); 
            item.style.display = "none"; 
            delete item;
            item = percentChanges.pop(); 
            item.style.display = "none"; 
            delete item;
            item = backgroundImages.pop(); 
            item.style.display = "none"; 
            delete item;
            item = deleteButtons.pop(); 
            item.style.display = "none"; 
            delete item;
        }

        oldCount = count;
        return;
    }

    if (window.widget)
    {
        portfolioSymbols = widget.preferenceForKey ("userSymbols");
        if(portfolioSymbols == "EMPTY")
        {
            return;
        }
    }


    var contents = document.getElementById("contents");

    for (var itemCount = symbolCount; itemCount < count; itemCount++)
    {
        backgroundOffset = (itemCount * 26);
        backgroundOffsets[itemCount] = backgroundOffset;

        var row = document.createElement('div');
        row.setAttribute("class", "row");
        backgroundImages[itemCount] = row;

        var span = document.createElement('span');
        span.setAttribute ("class", "col_Symbol");
        span.innerText = "Symbol";
       	row.appendChild(span);
        theSymbols[itemCount] = span;

        div= document.createElement('div');
        div.setAttribute ("class", "directions");
        row.appendChild(div);
        directions[itemCount] = div;

        span = document.createElement('span');
        span.setAttribute ("class", "col_Price");
        span.innerText = "Price";
       	span.style.left = isMinimized ? "50px" : "49px";
        row.appendChild(span);
        values[itemCount] = span;

        var span = document.createElement('span');
        span.setAttribute ("class", "col_Chg");
        span.innerText = "Chg";
        row.appendChild(span);
        pointChanges[itemCount] = span;

        span = document.createElement('span');
        span.setAttribute ("class", "col_PctChg");
        span.innerText = "PctChg";
        row.appendChild(span);
        percentChanges[itemCount] = span;

        div= document.createElement('div');
        div.setAttribute ("class", "delete");
        row.appendChild(div);
        deleteButtons[itemCount] = div;

        contents.appendChild (row);

    }
    
    if(isMinimized)
    {
        for (var itemCount = symbolCount; itemCount < count; itemCount++)
        {
            backgroundImages[itemCount].style.width="144px";
            pointChanges[itemCount].style.opacity = 0;
            percentChanges[itemCount].style.opacity = 0;
            deleteButtons[itemCount].style.left="125px";
        }
    }
    
    oldCount = count;
    scrollArea.reveal(document.getElementById('contents'));
    scrollArea.refresh();

}

function updateBoard()
{

	var portfolioSymbols;
    if (window.widget && widget)
    {
		portfolioSymbols = widget.preferenceForKey ("userSymbols");
		if(portfolioSymbols == "EMPTY")
		{
			return;
		}
		if (!(portfolioSymbols && portfolioSymbols > 0))
		{
			portfolioSymbols = DEFAULT_PORTFOLIO_SYMBOLS;
		}
    }
    portfolioSymbols = portfolioSymbols.replace(/\r|\n/,"");
    portfolioSymbols = portfolioSymbols.replace(" ","");
    portfolio = portfolioSymbols.split(",");

    var colorState = "#FFFFFF";
    if (portfolio == "")
    {
		buildBoard(0);
		return;
    }
    switch (sortOrder)
    {
		case "pctChgDesc" :
			sortArray.sort(sortPctChangeDesc);
			break;
		case "pctChgAsc" :
			sortArray.sort(sortPctChangeAsc);
			break;
		case "ChgDesc" :
			sortArray.sort(sortChangeDesc);
			break;
		case "ChgeAsc" :
			sortArray.sort(sortChangeAsc);
			break;
		case "PriceDesc" :
			sortArray.sort(sortPriceDesc);
			break;
		case "PriceAsc" :
			sortArray.sort(sortPriceAsc);
			break;
		case "SymbolDesc" :
			sortArray.sort(sortSymbolDesc);
			break;
		case "SymbolAsc" :
			sortArray.sort(sortSymbolAsc);
			break;
		default :
			sortArray.sort(sortPctChangeDesc);
    }
	for (item in sortArray)
	{
		var pctChgValue = sortArray[item][3];
		
		if ( sortArray[item][3][0] == "-" )
		{
			colorState = "#FE3131";
			directions[item].style.background = "url(Images/Row-Arrow_loss.png) no-repeat";
		}
		else
		{
			colorState = "#00FE00";
			directions[item].style.background = "url(images/Row-Arrow_gain.png) no-repeat";
		}
		
		if ( Number(sortArray[item][3]) == "0" )
		{
			colorState = "#FFFFFF";
			directions[item].style.background = "url(Images/Static.png) no-repeat";
		}


		if (panelPref == 0)
		{
			directions[item].style.display = "none"
			theSymbols[item].style.color = "#FFFFFF";
		
			if(pctChgValue >= 0.01 && pctChgValue <= 0.25)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_gain_.01-.49%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_gain_.01-.49.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover', "rowImgChange('" + item + "','Images/Row_Heat-Map_gain_.01-.49%_over.png','Images/delete_gain_.01-.49_over.png')");	    
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_.01-.49%.png','Images/delete_gain_.01-.49.png')");
			}
			else if(pctChgValue >= 0.26 && pctChgValue <= 0.49)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_gain_.50-.99%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_gain_.50-.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_.50-.99%_over.png','Images/delete_gain_.50-.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_.50-.99%.png','Images/delete_gain_.50-.99.png')");
			}
			else if(pctChgValue >= 0.5 && pctChgValue <= 0.75)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_gain_1.0-2.99%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_gain_1.0-2.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_1.0-2.99%_over.png','Images/delete_gain_1.0-2.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_1.0-2.99%.png','Images/delete_gain_1.0-2.99.png')");
			}
			else if(pctChgValue >= 0.76 && pctChgValue <= 0.99)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_gain_3.0-5.99%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_gain_3.0-5.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_3.0-5.99%_over.png','Images/delete_gain_3.0-5.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_3.0-5.99%.png','Images/delete_gain_3.0-5.99.png')");
			}
			else if(pctChgValue >= 1)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_gain_6+.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_gain_6+.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_6+_over.png','Images/delete_gain_6+_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_gain_6+.png','Images/delete_gain_6+.png')");
			}
			else if(pctChgValue <= -0.01 && pctChgValue >= -0.25)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_loss_.01-.49%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_loss_.01-.49.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_.01-.49%_over.png','Images/delete_loss_.01-.49_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_.01-.49%.png','Images/delete_loss_.01-.49.png')");
			}
			else if(pctChgValue <= -0.26 && pctChgValue >= -0.49)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_loss_.50-.99%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_loss_.50-.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_.50-.99%_over.png','Images/delete_loss_.50-.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_.50-.99%.png','Images/delete_loss_.50-.99.png')");
			}
			else if(pctChgValue <= -0.5 && pctChgValue >= -0.75)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_loss_1.0-2.99%.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_loss_1.0-2.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_1.0-2.99%_over.png','Images/delete_loss_1.0-2.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_1.0-2.99%.png','Images/delete_loss_1.0-2.99.png')");
			}
			else if(pctChgValue <= -0.76 && pctChgValue >= -0.99)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_loss_3.0-5.99.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_loss_3.0-5.99.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_3.0-5.99%_over.png','Images/delete_loss_3.0-5.99_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_3.0-5.99.png','Images/delete_loss_3.0-5.99.png')");
			}
			else if(pctChgValue <= -1.0)
			{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_loss_6.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_loss_6.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_6_over.png','Images/delete_loss_6_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_loss_6.png','Images/delete_loss_6.png')");
			}
			else{
				backgroundImages[item].style.background = "url(Images/Row_Heat-Map_no-loss-gain.png) no-repeat";
				deleteButtons[item].style.background = "url(Images/delete_no-loss-gain.png) no-repeat";
				backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row_Heat-Map_no-loss-gain_over.png','Images/delete_no-loss-gain_over.png')");
				backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row_Heat-Map_no-loss-gain.png','Images/delete_no-loss-gain.png')");
			}
		}
		else{
			directions[item].style.display = "block";
			theSymbols[item].style.color = colorState;
			backgroundImages[item].style.background = "url(Images/Row-Arrow_no-loss-gain.png) no-repeat";
			deleteButtons[item].style.background = "url(Images/delete_no-loss-gain.png) no-repeat";
			backgroundImages[item].setAttribute ('onmouseover',"rowImgChange('" + item + "','Images/Row-Arrow_no-loss-gain_over.png','Images/delete_no-loss-gain_over.png')");
			backgroundImages[item].setAttribute ('onmouseout',"rowImgChange('" + item + "','Images/Row-Arrow_no-loss-gain.png','Images/delete_no-loss-gain.png')");
		}

		// shows details once user clicks on row
		theSymbols[item].setAttribute ('onclick',"showTabs(\"" + item + "\");");
		values[item].setAttribute ('onclick',"showTabs(\"" + item + "\");");
		pointChanges[item].setAttribute ('onclick',"showTabs(\"" + item + "\");");
		percentChanges[item].setAttribute ('onclick',"showTabs(\"" + item + "\");");

		var toolTip = sortArray[item][4] + " as of: " + sortArray[item][5] + " " + sortArray[item][6] + " ET";
		backgroundImages[item].setAttribute("title",toolTip);
		deleteButtons[item].setAttribute ('onclick',"deleteItem(\"" + item+ "\");");
		theSymbols[item].innerText = sortArray[item][0];
		
		var priceChange = sortArray[item][2];
		sortArray[item][1] = Number(sortArray[item][1]).toFixed(2);
		sortArray[item][2] = Number(priceChange).toFixed(2);
		sortArray[item][3] = Number(sortArray[item][3]).toFixed(2);
	
		theSymbols[item].style.fontSize = "9px";
		values[item].style.fontSize = "9px";
		pointChanges[item].style.fontSize = "9px";
		percentChanges[item].style.fontSize = "9px";
	
		values[item].innerText = sortArray[item][1];
		// remove negative sign if truncated price change is 0
		if(priceChange < 0 && sortArray[item][2] == 0)
		{
			sortArray[item][2] = sortArray[item][2].replace("-","");
		}
		pointChanges[item].innerText = sortArray[item][2];
		percentChanges[item].innerText = sortArray[item][3];

	}
	
	if(theSymbols != null)
	{
    	for( n=0; n < theSymbols.length; n++ )
		{
			theSymbols[n].style.opacity = 1;
			values[n].style.opacity = 1;
			if (isMinimized == false){
				pointChanges[n].style.opacity = 1;
				percentChanges[n].style.opacity = 1;
			}
			if (panelPref == 1)
			{
				directions[n].style.opacity = 1;
			}
		}
	}

	scrollArea.reveal(document.getElementById('contents'));
	scrollArea.refresh();
}

function addButtonMouseOver (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function addButtonMouseOut (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function rowImgChange(rowNumber,rowImg,deleteImg)
{
    if(!isInResizeMode){
		if(backgroundImages[rowNumber]){
			backgroundImages[rowNumber].style.background = "url(" + rowImg + ") no-repeat";
			deleteButtons[rowNumber].style.background = "url(" +deleteImg+ ") no-repeat";
		}
    }
}

function sortPctChangeDesc(a, b)
{
 	return	 b[3] - a[3];
}

function sortPctChangeAsc(a, b)
{
	return	 a[3] - b[3];
}
function sortChangeDesc(a, b)
{
	return	 b[2] - a[2];
}

function sortChangeAsc(a, b)
{
 	return	 a[2] - b[2];
}
function sortPriceDesc(a, b)
{
 	return	 b[1] - a[1];
}

function sortPriceAsc(a, b)
{
 	return	 a[1] - b[1];
}
function sortSymbolAsc(a, b)
{
 	return a[0] < b[0] ? -1 :
   			a[0] > b[0] ? 1 : 0;
}

function sortSymbolDesc(a, b)
{
 	return a[0] > b[0] ? -1 :
   			a[0] < b[0] ? 1 : 0;
}



/* ***	Window resizing *** */
var lastPos;

function mouseDown(event)
{
    isInResizeMode = true;
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;

	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}


function mouseMove(event)
{
    var screenY = event.y + 20 + window.screenY;
    var deltaY = 0;
    
    if (screenY > 780) return;

    if ( (window.outerHeight + (screenY - lastPos.y)) >= 357 ) {
	deltaY = screenY - lastPos.y;
	lastPos.y = screenY;
    }


	window.resizeBy(0, deltaY);
	scrollArea.reveal(document.getElementById('contents'));
	scrollArea.refresh();
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event)
{
	isInResizeMode = false;
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);
	event.stopPropagation();
	event.preventDefault();
	firstTime = false;
	currentHeight = window.innerHeight;

}



/* --------- mousewheel scrolling ---------- */

function mouseWheelMove(event) 
{
    var clicks = window.event.wheelDelta/20;
}

function enterBottomControls(event)
{
    document.getElementById('bottom-controls_shadow').style.display = 'block';
}

function exitBottomControls(event)
{
    document.getElementById('bottom-controls_shadow').style.display = 'none';
}

function moveToRight() 
{
    boundryR = 546;
    if (positionY < boundryR)
    {
		positionY += 19;
		document.getElementById('panel_open-right').style.left = positionY + "px";
    }
    else{
		clearInterval(moveFunction);
		showPanelContent();
		isMoving = false;
    }
}

function moveToLeft() 
{
    boundryL = 0;
    if (positionY > boundryL)
    {
		positionY -= 19;
		if(positionY < 0)
		{
			positionY = 0;
		}
		document.getElementById('panel_open-right').style.left = positionY + "px";
    }
    else{
		clearInterval(moveFunction);
		showPanelContent();
		isMoving = false;
    }
}

function movePanel()
{
    if(isMoving) 
    {
    	return;
    }
    isMoving = true;
    positionY = 266;
    document.getElementById('panel_open-right').style.left = "266px";
    document.getElementById('panel_open-right').style.display = "block";
    currentHeight = window.innerHeight;

    var remainingSpace = (window.screen.width - window.screenX);

    if (remainingSpace < 840)
    {
		panelOrientation = "left";
		document.getElementById('panel_open-right').style.background = "url(Images/panel_open-left.png)";
		moveFunction = setInterval("moveToLeft()", 30);
    }
    else{
		panelOrientation = "right";
		document.getElementById('panel_open-right').style.background = "url(Images/panel_open-right.png)";
		positionY = (positionY - 5);
		moveFunction = setInterval("moveToRight()", 30);
    }

    document.getElementById('panel_open-right').style.display = "block";

}

function showPanelContent()
{
    document.getElementById('close_panel').style.opacity = 255;
}

function resizeWidget()
{
    if(isMinimized)
    {
		maximizeWidget();
    }
    else{
		minimizeWidget();
    }
}

function minimizeWidget()
{
    isMinimized = true;
    closePanel();
    var widgetSize = "150px";
    document.getElementById('topBar').style.width = widgetSize;
    document.getElementById('topBar').style.background = "url('Images/panel_top_150.png') no-repeat";
    document.getElementById('topBar').style.height = "38px";
    document.getElementById('topBar').style.top = "65px";
    document.getElementById('logo').style.top = "69px";
    document.getElementById('center').style.width = widgetSize;
    document.getElementById('center').style.background = "url('Images/panel_middle_150.png') repeat-y";
    document.getElementById('center').style.top ="103px";
    document.getElementById('bottomBar').style.width = widgetSize;
    document.getElementById('bottomBar').style.background = "url('Images/panel_bottom_150.png') no-repeat";
    document.getElementById('ResizeBox').style.left = "139px";
    document.getElementById('Add_textfield').style.display = "none";
    document.getElementById('Add_button').style.display = "none";
    document.getElementById('Symbol_Search_button').style.display = "none";
    document.getElementById('Column-Headers').style.display = "none";
    document.getElementById('myScrollBar').style.display = "none";
    document.getElementById('quotes_delayed').style.width = "100px";
    document.getElementById('quotes_delayed').style.bottom = "45px";
    document.getElementById('legal').style.display = "none";
    document.getElementById('bottom-controls_minimize').src = "Images/bottom-controls_maximize.png";

    for (item in sortArray)
    {
        backgroundImages[item].style.width = "144px";
        pointChanges[item].style.opacity = 0;
        percentChanges[item].style.opacity = 0;
        
        values[item].style.left="50px";
        deleteButtons[item].style.left= "125px";
    }
    
    scrollArea.refresh();
    
    debug("minimizeWidget");
}

function maximizeWidget()
{

    isMinimized = false;
    var widgetSize = "280px";
    document.getElementById('topBar').style.width = widgetSize;
    document.getElementById('topBar').style.background = "url('Images/panel_top.png') no-repeat";
    document.getElementById('topBar').style.height = "77px";
    document.getElementById('topBar').style.top = "0px";
    document.getElementById('logo').style.top = "12px";
    document.getElementById('center').style.width = widgetSize;
    document.getElementById('center').style.background = "url('Images/panel_middle.png') repeat-y";
    document.getElementById('center').style.top ="77px";
    document.getElementById('bottomBar').style.width = widgetSize;
    document.getElementById('bottomBar').style.background = "url('Images/panel_bottom.png') no-repeat";
    document.getElementById('ResizeBox').style.left = "269px";
    document.getElementById('Add_textfield').style.display = "block";
    document.getElementById('Add_button').style.display = "block";
    document.getElementById('Symbol_Search_button').style.display = "block";
    document.getElementById('Column-Headers').style.display = "block";
    document.getElementById('myScrollBar').style.display = "block";
    document.getElementById('quotes_delayed').style.width = widgetSize;
    document.getElementById('quotes_delayed').style.bottom = "55px";
    document.getElementById('legal').style.display = "block";
    document.getElementById('bottom-controls_minimize').src = "Images/bottom-controls_minimize.png";

    for (item in sortArray)
    {
        backgroundImages[item].style.width = "255px";
        pointChanges[item].style.opacity = 255;
        percentChanges[item].style.opacity = 255;
        deleteButtons[item].style.left= "235px";
    }
    
    scrollArea.refresh();
    
    debug("maximizeWidget()");
}

function closePanel()
{
    document.getElementById('panel_open-right').style.left = "266px";
    document.getElementById('panel_open-right').style.display = "none";
    document.getElementById('close_panel').style.opacity = 0;
    document.getElementById('symbolSearch').style.display = "none";
    document.getElementById('tabs').style.display = "none";
    document.getElementById('info').style.display = "none";
    document.getElementById('pref').style.display = "none";
    clearInterval(chartsInterval);
    clearInterval(newsInterval);
    clearInterval(detailsInterval);
}

function setSearchFieldFocus()
{
    document.getElementById("SearchField").focus();
    document.getElementById("SearchField").select();
}

function displaySymbolSearch()
{
    chosenTab = "symbollookup";
    if(isMoving) return;
    closePanel();

    while ( theStockSymbols.length > 0 )
    {
	item = theStockSymbols.pop(); item.style.display = "none"; delete item;
	item = theStockNames.pop(); item.style.display = "none"; delete item;
	item = stockAdd.pop(); item.style.display = "none"; delete item;
    }
    document.getElementById("SearchField").value = "";
    document.getElementById("type_lookup_dropdown").value="stock";
    movePanel();
    document.getElementById('symbolSearch').style.display = 'block';
    document.getElementById("SearchField").focus();
}

function doSymbolSearch( query, type, market )
{
    setTimeout('setSearchFieldFocus();',0);
    document.getElementById('loading_data').innerText = "Loading Data...";
    //spinner.opacity = 255;
    box = document.getElementById("type_lookup_dropdown");
    type = box.options[box.selectedIndex].value;
    if (query == "")
    {
		document.getElementById('loading_data').innerText = "";
		return;
    }
    query = query.replace(/\r|\n/,"");
    if (ValidateInput(query) == false)
	{
		//spinner.opacity = 0;
		document.getElementById('loading_data').innerText = "";
		displayMessage("You have entered invalid characters in the search");
		debug("doSymbolSearch: You have entered invalid characters in the search");
		return;
	}

	var now = new Date();
    url = g_QuoteHostname + "/service/lookup/full?criteria=" + query + "&for=" + type + "&by=" + market + "&productid=widget&rows=100&version=1.0&ts="+now.getTime();
    debug("url="+url);
    var xml_request = new XMLHttpRequest();
    xml_request.onload = function(e) {finishSearch(e, xml_request);}
    xml_request.overrideMimeType("text/xml");
    xml_request.open("GET", url);
    xml_request.setRequestHeader("Cache-Control", "no-cache");
    xml_request.send(null);

}


function finishSearch(event, request)
{

    var doc;
    var resultNodes;
    var backgroundOffset = 0;
    stockNames = new Array();
    stockSymbols = new Array();
    var horizOffset = 5;
    var query = document.getElementById("SearchField").value;
    box = document.getElementById("type_lookup_dropdown");
    var type = box.options[box.selectedIndex].value;

    if (!request.responseXML)
    {	
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		document.getElementById('loading_data').innerText = "";
		return 0;
    }

    try
    {
		doc = request.responseXML;
		resultNodes =doc.getElementsByTagName("ROW");
    }
    catch( e )
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		document.getElementById('loading_data').innerText = "";
		return 0;
    }

	var Results_data_contents = document.getElementById("Results_data_contents");
	
	while ( theStockSymbols.length > 0 )
	{
		item = theStockSymbols.pop(); item.style.display = "none"; delete item;
		item = theStockNames.pop(); item.style.display = "none"; delete item;
		item = stockAdd.pop(); item.style.display = "none"; delete item;
	}

	if ( resultNodes.length > 0 )
	{
		for (var n = 0; n < resultNodes.length; n++)
		{
	
			var searchedSymbol = findChild(resultNodes.item(n), "SYMBOL");
			var stockSymbolValue = searchedSymbol.firstChild.data;
			var searchedName = findChild(resultNodes.item(n), "NAME");
			var stockNameValue =  searchedName.firstChild.data;
		
		
			var row= document.createElement('div');
			row.setAttribute("class", "searchRow");
			if (stockNameValue.length > 17)
			{
				row.style.background = "url(images/Results_result_2_line.png) no-repeat";
				row.style.height = "52px";
				row.setAttribute ('onmouseover',"searchRowImgChange('" + n + "','Images/Results_over_2_line.png')");
				row.setAttribute ('onmouseout',"searchRowImgChange('" + n + "','Images/Results_result_2_line.png')");
			}
			else{
				row.style.background = "url(images/Results_result.png) no-repeat";
				row.style.height = "26px";
				row.setAttribute ('onmouseover',"searchRowImgChange('" + n + "','Images/Results_over.png')");
				row.setAttribute ('onmouseout',"searchRowImgChange('" + n + "','Images/Results_result.png')");
			}
		
			row.setAttribute ('onclick', "writePrefs(\"" + stockSymbolValue + "\");");
			stockAdd[n] = row;
		
			var span = document.createElement('span');
			span.setAttribute ("class", "search_col_Symbol");
			span.innerText = stockSymbolValue;
			span.style.top = "4px";
			row.appendChild(span);
			theStockSymbols[n] = span;
		
			if (stockNameValue.length > 40) 
			{
				stockNameValue =  stockNameValue.substring(0, 40) + "...";
			}
			span = document.createElement('span');
			span.setAttribute ("class", "search_col_Name");
			span.innerText = stockNameValue;
			span.style.top = "4px";
			row.appendChild(span);
			theStockNames[n] = span;
		
			Results_data_contents.appendChild (row);
		}
	}
	else{
		document.getElementById('loading_data').innerText = "";
		displayMessage("The " + type + " you were searching for was not found." );
		debug( "The " + type + " you were searching for was not found." );
		connected = false;
		return 0;
	}
	document.getElementById('loading_data').innerText = "";
	Results_data_scrollArea.reveal(document.getElementById('Results_data_contents'));
	Results_data_scrollArea.refresh();

}

function searchRowImgChange(rowNumber,rowImg)
{
    if(stockAdd[rowNumber])
    {
		stockAdd[rowNumber].style.background = "url(" + rowImg + ") no-repeat";
    }
}

function searchKeyPress (event,query)
{
    switch (event.keyCode)
    {
		case 13: // return
		case 3:	 // enter
		doSymbolSearch( query, 'stock','name' );
    }
}

/*-------Tabs Panel ----------------*/

function showTabs(selectedItem)
{
    if(isMoving) 
    {
    	return;
    }
    closePanel();
    chosenSymbol = sortArray[selectedItem][0];
    chosenItem = selectedItem;
    tabsOpen = true;
    //cleanTabs();
    if (isMinimized) maximizeWidget();
    movePanel();
    document.getElementById('tabs').style.display = "block";

    var companyNamedetails = sortArray[selectedItem][4];
    if (companyNamedetails.length > 20) companyNamedetails = companyNamedetails.substring(0, 20) + "...";
    var company_name = document.getElementById('company_name');
    company_name.innerText = companyNamedetails;
    company_name.title = sortArray[selectedItem][4];
    var url = g_ResearchUrl + "/eresearch/goto/evaluate/snapshot.jhtml?symbols=" + chosenSymbol;
    company_name.setAttribute ("onclick", "widget.openURL('" + url + "')");
    getDetails();
}

function cleanTabs()
{
    document.getElementById('details_unselected').style.display = "none";
    document.getElementById('charts_unselected').style.display = "none";
    document.getElementById('news_unselected').style.display = "none";
    document.getElementById('details_selected').style.display = "none";
    document.getElementById('charts_selected').style.display = "none";
    document.getElementById('news_selected').style.display = "none";

    clearInterval(chartsInterval);
    clearInterval(newsInterval);
    clearInterval(detailsInterval);
}

function getCharts()
{
    chosenTab = "charts";
    document.getElementById('quote_date').innerText = "Loading Data...";
    cleanTabs();
    document.getElementById('charts_selected').style.display = "block";
    document.getElementById('details_unselected').style.display = "block";
    document.getElementById('news_unselected').style.display = "block";

    clearInterval(chartsInterval);
    chartsInterval = setInterval('getCharts();', pollIntervalValue);

    var time;
    var freq;
    var chartOtions = new Object(   );

    chartOtions["equity"] = [
		{
			value:"Intraday", 
			text:"Intraday"
		},
    	{
    		value:"1 Week", 
    		text:"1 Week"
    	},
    	{
    		value:"30-Day", 
    		text:"30-Day"
    	},
    	{
    		value:"3 Months", 
    		text:"3 Months"
    	},
    	{
    		value:"1 Year", 
    		text:"1 Year"
    	},
    	{
    		value:"3 Years", 
    		text:"3 Years"
    	},
    	{
    		value:"5 Years", 
    		text:"5 Years"
    	}
    ];

    chartOtions["mf"]= [
    	{
    		value:"30-Day",
    		text:"30-Day"
    	},
    	{
    		value:"3 Months", 
    		text:"3 Months"
    	},
    	{
    		value:"1 Year", 
    		text:"1 Year"
    	},
    	{
    		value:"3 Years", 
    		text:"3 Years"
    	},
    	{
    		value:"5 Years", 
    		text:"5 Years"
    	}
    ];

    var db;

    if(securityTypeValue == "MutualFund" || securityTypeValue == "SelectFund" || securityTypeValue == "Annuity" || securityTypeValue == "MoneyMarket")
    {
        db = chartOtions["mf"];
        time = "4";
        freq = "1";
    }
    else
    {
        db = chartOtions["equity"];
        time = "1";
        freq = "7";
    }

    var box = document.getElementById('charts_dropdown');
    while (box.options.length > 0) 
    {
        box.remove(0);
    }

    for (var i = 0; i < db.length; i++) 
    {
        newElem = document.createElement("option");
        newElem.text = db[i].text;
        newElem.value = db[i].value;
        box.add(newElem, null);
    }

    var theURL = g_ChartUrl + "/custom/fidelity-com/wireless/ss-gif-lg-ii.img?uf=8192&type=256&symb=" + chosenSymbol + "&time=" + time + "&freq=" + freq;
    if(/(\d+)|(\w+\/\w+)/.test(chosenSymbol))
    {
        document.getElementById('displayChart').style.display = "none";
        document.getElementById('charts_error').innerHTML = "Currently this chart is not available";
    }
    else
    {
        document.getElementById('charts_error').innerHTML = "";
        document.getElementById('displayChart').style.display = "block";
        document.getElementById('displayChart').src = theURL;
    }
    document.getElementById('quote_date').innerText = "";
}


function chartsReceived( url )
{
    displayChart.opacity = 255;
    displayChart.src = url.location;
    displayChart.vOffset = 125;
    displayChart.hOffset = 40;
    detailsFrame.addSubview( displayChart );
    quote_date.data = "";
    quote_date.opacity = 0;
}


function updateChart()
{
    document.getElementById('quote_date').innerText = "Loading Data...";
    var time;
    var freq;
    var box = document.getElementById('charts_dropdown');
    var chartDropdownValue = box.options[box.selectedIndex].value;
    switch (chartDropdownValue)
    {
        case "Intraday" :
            time = "1";
            freq = "7";
            break;
        case "1 Week" :
            time = "3";
            freq = "7";
            break;
        case "30-Day" :
            time = "4";
            freq = "1";
            break;
        case "3 Months" :
            time = "6";
            freq = "1";
            break;
        case "1 Year" :
            time = "8";
            freq = "2";
            break;
        case "3 Years" :
            time = "10";
            freq = "3";
            break;
        case "5 Years" :
            time = "12";
            freq = "4";
            break;
        default :
            time = "1";
            freq = "7";
    }
    var theURL = g_ChartUrl + "/custom/fidelity-com/wireless/ss-gif-lg-ii.img?uf=8192&type=256&symb=" + chosenSymbol + "&time=" + time + "&freq=" + freq;
    displayChart.src = theURL;
    document.getElementById('quote_date').innerText = "";
}

function getNews()
{

    chosenTab = "news";
    document.getElementById('quote_date').innerText = "Loading Data...";
    cleanTabs();

    document.getElementById('news_selected').style.display = "block";
    document.getElementById('details_unselected').style.display = "block";
    document.getElementById('charts_unselected').style.display = "block";

    clearInterval(newsInterval);
    newsInterval = setInterval('getNews();', pollIntervalValue);

    while ( newsHeadlineTextArray.length > 0 )
    {
        item = newsHeadlineTextArray.pop(); item.style.display = "none"; 
        delete item;
        item = newsSourceTextArray.pop(); item.style.display = "none"; 
        delete item;
        item = newsDateTimeTextArray.pop(); item.style.display = "none"; 
        delete item;
        item = newsSpaceTextArray.pop(); item.style.display = "none"; 
        delete item;
    }
    if(newsMoreTextArray.length > 0 )
    {
        item = newsMoreTextArray.pop(); item.style.display = "none"; 
        delete item;
    }
    if(newsErrorTextArray.length > 0 )
    {
        item = newsErrorTextArray.pop(); item.style.display = "none"; 
        delete item;
    }

    var url = g_NewsHostname + "/json/getNews/getHeadlines.htm";
    
    var request = {
        "authDetails":{
            "memberId":"_",
            "userId":"_",
            "sessionKey":"_",
            "role":"FidelityLabs"
        },
        "headlineSearch":[{
            "criteria":{
                "@type":".ComplexSearch",
                "symbols":{"symbol":[chosenSymbol]},
                "numHeadlines":10
            }
        }]
    };
    
    var httpRequest = new XMLHttpRequest();
    httpRequest.onload = function(e) {
        newsReceived(e, httpRequest);
    }
    httpRequest.open("POST", url);
    var body = JSON.stringify(request);
    debug("url=" + url + " body:" + body);
    httpRequest.setRequestHeader("Content-Type","application/json");
    httpRequest.setRequestHeader("Accept","application/json");
    httpRequest.setRequestHeader("Cache-Control", "no-cache");
    httpRequest.send(body);
}

function newsReceived(event, httpRequest)
{
    function formatDateTime(dateStr, timeStr)
    {
        var now = new Date();
        var y = parseInt(dateStr.substring(0,4),10);
        var m = parseInt(dateStr.substring(4,6),10);
        var d = parseInt(dateStr.substring(6),10);
        var h = parseInt(timeStr.substring(0,2),10);
        var i = timeStr.substring(2);
        
        function formatTime(h,i)
        {
            var hours = h - (h > 12 ? 12 : 0);
            var amPm = h > 12 ? "PM" : "AM";
            return hours + ":" + i + " " + amPm + " ET";
        }
        
        if(now.getFullYear() == y && (now.getMonth()+1) == m && now.getDate() == d)
        {
            return formatTime(h,i);
        }
        else
        {
            return m + "/" + d + "/" + y + " " + formatTime(h,i);
        }
    }

    var resultNodes;

    if (!httpRequest.responseText)
    {
        displayGenericMsg();
        connected = false;
        return 0;
    }

    var json;
    try
    {
        json = JSON.parse(httpRequest.responseText);
    }
    catch( e )
    {
        displayGenericMsg();
        connected = false;
        return 0;
    }

    var status;
    try{
        status = json.headlineResults[0].responseStatus;
    }catch(e)
    {
        displayGenericMsg();
        connected = false;
        return 0;
    }
    
    news_contents.innerHTML = "";
    if (status.statusCode < 0)
    {
        var div = document.createElement('div');
        div.setAttribute ("class", "news_error");
        div.innerText = status.statusMessage;
        newsErrorTextArray[0] = div;
        news_contents.appendChild (div);
    }
    else
    {
        var resultNodes;
        try{
            resultNodes = json.headlineResults[0].headline;
        }catch(e)
        {
            displayGenericMsg();
            connected = false;
            return 0;
        }
        
        for (n = 0; n < resultNodes.length; n++)
        {
            var url = g_ResearchUrl + "/eresearch/goto/evaluate/news/basicNewsStory.jhtml?symbols="+chosenSymbol+"&storyid="+resultNodes[n].resId;

            var div = document.createElement('div');
            div.setAttribute ("class", "news_text");
            div.setAttribute ('onclick', "widget.openURL(\"" + url + "\");");
            div.innerText = resultNodes[n].text;
            newsHeadlineTextArray[n] = div;
            news_contents.appendChild (div);

            var div = document.createElement('div');
            div.setAttribute ("class", "news_source");
            div.innerText = resultNodes[n].wirename;
            newsSourceTextArray[n] = div;
            news_contents.appendChild (div);

            var div = document.createElement('div');
            div.setAttribute ("class", "news_source");
            newsDateTimeTextArray[n] = div;
            div.innerText = formatDateTime(resultNodes[n].resDate,resultNodes[n].resTime);

            news_contents.appendChild (div);
            var div = document.createElement('div');
            div.setAttribute ("class", "news_space");
            newsSpaceTextArray[n] = div;
            news_contents.appendChild (div);

        }

        if (resultNodes.length > 9)
        {
            var url = g_ResearchUrl + "/eresearch/goto/evaluate/news/basicNews.jhtml?symbols=" + chosenSymbol;
            var div = document.createElement('div');
            div.setAttribute ("class", "news_more");
            div.setAttribute ('onclick', "widget.openURL(\"" + url + "\");");
            div.innerText = "More";
            news_contents.appendChild (div);
            newsMoreTextArray[0]  = div;
            
            var div = document.createElement('div');
            div.setAttribute ("class", "news_space");
            newsSpaceTextArray[n] = div;
            news_contents.appendChild (div);
        }
    }
    
    news_scrollArea.reveal(document.getElementById('news_contents'));
    news_scrollArea.refresh();
    document.getElementById('quote_date').innerText = "";

}

function launchNewsStory(storyID)
{
	var url = storyID;
	openURL(url);
}


function getDetails()
{
    chosenTab = "details";
    document.getElementById('quote_date').innerText = "Loading Data...";
    cleanTabs();
    document.getElementById('details_selected').style.display = "block";
    document.getElementById('charts_unselected').style.display = "block";
    document.getElementById('news_unselected').style.display = "block";

    debug("fire details");
    clearInterval(detailsInterval);
    detailsInterval = setInterval('getDetails();', pollIntervalValue);

	var now = new Date();
    url = g_QuoteHostname + "/service/quote/full?productid=widget&version=1.0&symbols=" + chosenSymbol + "&ts=" + now.getTime();
    debug("url=" + url);
    var xml_request = new XMLHttpRequest();
    xml_request.onload = function(e) {detailsReceived(e, xml_request);}
    xml_request.overrideMimeType("text/xml");
    xml_request.open("GET", url);
    xml_request.setRequestHeader("Cache-Control", "no-cache");
    xml_request.send(null);
}




function detailsReceived(event, request )
{
    var doc;
    var resultNodes;

    if (!request.responseXML)
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

    try
    {
		doc = request.responseXML;
		resultNodes =doc.getElementsByTagName("QUOTE_DATA");
    }
    catch( e )
    {
		displayGenericMsg();
		debug(genericErrMsg);
		connected = false;
		return 0;
    }

	quoteCount = 0;
	var symbolValue;
	var nameValue;
	var lasttradeValue;
	var changeValue;
	var pctchangeValue;
	var bidValue;
	var bidSizeValue;
	var askValue;
	var askSizeValue;
	var volumeValue;
	var openValue;
	var dayHighValue;
	var dayLowValue;
	var prevCloseValue;
	var prevCloseDateValue;

	if (resultNodes == null)
    {
        displayMessage("There was a problem parsing search results.");
        debug("There was a problem parsing search results.");
        return;
    }
    else
    {
        try
        {
            var lastDate =	 getNodeValue(doc.getElementsByTagName("SELECT_LATESTDATE"));
            if (lastDate == "")
            {
                var time = getNodeValue(doc.getElementsByTagName("LAST_TIME"));
                lastDate += time + (time ? " ET" : "");
            }
            if (lastDate == "")
            {
            	lastDate = getNodeValue(doc.getElementsByTagName("NAV_DATE"));
        	}
            var lastTradeTime = lastDate + "  " + getNodeValue(doc.getElementsByTagName("LAST_DATE"));//doc.evaluate( "string(QUOTE/SYMBOL_RESPONSE/QUOTE_DATA/LAST_DATE)" );
            document.getElementById('quote_date').innerText = lastTradeTime;

            detailsArray = new Array();
            detailsHeadersArray = new Array();
            securityTypeValue = getNodeValue(doc.getElementsByTagName("SECURITY_TYPE"));//node.evaluate("string(SECURITY_TYPE)");
        }
        catch( e )
        {
            securityTypeValue = "NotAvailable";
        }

		switch (securityTypeValue)
		{
			case "NotAvailable" :
				detailsHeadersArray[0] = "Details are not available at this time.";
				detailsArray[0] = "Please try again later.";
				break;
			case "Equity" :
				try{
					lasttradeValue = getNodeValue(doc.getElementsByTagName("LAST_PRICE"));
					if(lasttradeValue == "")
					{
						lasttradeValue = "N/A";
					}
				}
				catch(e)
				{
					lasttradeValue = "N/A";
				}
				detailsHeadersArray[0] = "Last [Tick]";
				detailsArray[0] = lasttradeValue;
			
				try{
					changeValue = getNodeValue(doc.getElementsByTagName("NETCHG_TODAY"));
					if(changeValue == "") 
					{
						changeValue = "N/A";
					}
				}
				catch(e)
				{
					changeValue = "N/A";
				}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
					pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
					if(pctchangeValue == "")
					{
						pctchangeValue = "N/A";
					}
				}
				catch(e)
				{
					pctchangeValue = "N/A";
				}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
					bidValue = getNodeValue(doc.getElementsByTagName("BID_PRICE"));
					if(bidValue == "") 
					{
						bidValue = "N/A";
					}
				}
				catch(e)
				{
					bidValue = "N/A";
				}
				detailsHeadersArray[3] = "Bid";
				detailsArray[3] = bidValue;
				
				try{
					askValue = getNodeValue(doc.getElementsByTagName("ASK_PRICE"));
					if(askValue == "")
					{
						askValue = "N/A";
					}
				}
				catch(e)
				{
					askValue = "N/A";
				}
				detailsHeadersArray[4] = "Ask";
				detailsArray[4] = askValue;
				
				try{
					openValue = getNodeValue(doc.getElementsByTagName("OPEN_PRICE"));
					if (openValue == "")
					{
						openValue = "N/A";
					}
				}
				catch(e)
				{
					openValue = "N/A";
				}
				detailsHeadersArray[5] = "Open";
				detailsArray[5] = openValue;
			
				try{
					volumeValue = getNodeValue(doc.getElementsByTagName("VOLUME"));
					if (volumeValue == "")
					{
						volumeValue = "N/A";
					}
				}
				catch(e)
				{
					volumeValue = "N/A";
				}
				detailsHeadersArray[6] = "Volume";
				detailsArray[6] = volumeValue;
			
				try{
					askSizeValue = getNodeValue(doc.getElementsByTagName("PE_RATIO"));
					if(askSizeValue == "")
					{
						askSizeValue = "N/A";
					}
				}
				catch(e)
				{
					askSizeValue = "N/A";
				}
				detailsHeadersArray[7] = "P/E Ratio";
				detailsArray[7] = askSizeValue;
			
				try{
					dayHighValue = getNodeValue(doc.getElementsByTagName("DAY_HIGH"));
					if (dayHighValue == "")
					{
						dayHighValue = "N/A";
					}
				}
				catch(e)
				{
					dayHighValue = "N/A";
				}
				detailsHeadersArray[8] = "Day High";
				detailsArray[8] = dayHighValue;
			
				try{
					dayLowValue = getNodeValue(doc.getElementsByTagName("DAY_LOW"));
					if (dayLowValue == "")
					{
						dayLowValue = "N/A";
					}
				}
				catch(e)
				{
					dayLowValue = "N/A";
				}
				detailsHeadersArray[9] = "Day Low";
				detailsArray[9] = dayLowValue;
			
				try{
					prevCloseValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_PRICE"));
					if (prevCloseValue == "")
					{
						prevCloseValue = "N/A";
					}
				}
				catch(e)
				{
					prevCloseValue = "N/A";
				}
				detailsHeadersArray[10] = "Previous Close";
				detailsArray[10] = prevCloseValue;
			
				try{
					prevCloseDateValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_DATE"));
					if (prevCloseDateValue == "")
					{
						prevCloseDateValue = "N/A";
					}
				}
				catch(e)
				{
					prevCloseDateValue = "N/A";
				}
				detailsHeadersArray[11] = "Prev. Close Date";
				detailsArray[11] = prevCloseDateValue;
				break;
			case "Index" :
				try{
					lasttradeValue = getNodeValue(doc.getElementsByTagName("LAST_PRICE"));
					if(lasttradeValue == "")
					{
						lasttradeValue = "N/A";
					}
				}
				catch(e)
				{
					lasttradeValue = "N/A";
				}
				detailsHeadersArray[0] = "Last [Tick]";
				detailsArray[0] = lasttradeValue;
			
				try{
					changeValue = getNodeValue(doc.getElementsByTagName("NETCHG_TODAY"));
					if(changeValue == "")
					{
						changeValue = "N/A";
					}
				}
				catch(e)
				{
					changeValue = "N/A";
				}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
					pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
					if(pctchangeValue == "")
					{
						pctchangeValue = "N/A";
					}
				}
				catch(e)
				{
					pctchangeValue = "N/A";
				}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
					openValue = getNodeValue(doc.getElementsByTagName("OPEN_PRICE"));
					if (openValue == "")
					{
						openValue = "N/A";
					}
				}
				catch(e)
				{
					openValue = "N/A";
				}
				detailsHeadersArray[3] = "Open";
				detailsArray[3] = openValue;
			
				try{
					dayHighValue = getNodeValue(doc.getElementsByTagName("DAY_HIGH"));
					if (dayHighValue == "")
					{
						dayHighValue = "N/A";
					}
				}
				catch(e)
				{
					dayHighValue = "N/A";
				}
				detailsHeadersArray[4] = "Day High";
				detailsArray[4] = dayHighValue;
			
				try{
					dayLowValue = getNodeValue(doc.getElementsByTagName("DAY_LOW"));
					if (dayLowValue == "")
					{ 
						dayLowValue = "N/A";
					}
				}
				catch(e)
				{
					dayLowValue = "N/A";
				}
				detailsHeadersArray[5] = "Day Low";
				detailsArray[5] = dayLowValue;
			
				try{
					prevCloseValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_PRICE"));
					if (prevCloseValue == "")
					{
						prevCloseValue = "N/A";
					}
				}
				catch(e)
				{
					prevCloseValue = "N/A";
				}
				detailsHeadersArray[6] = "Previous Close";
				detailsArray[6] = prevCloseValue;
			
				try{
					prevCloseDateValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_DATE"));
					if (prevCloseDateValue == "")
					{
						prevCloseDateValue = "N/A";
					}
				}
				catch(e)
				{
					prevCloseDateValue = "N/A";
				}
				detailsHeadersArray[7] = "Prev. Close Date";
				detailsArray[7] = prevCloseDateValue;
				break;
			case "MutualFund":
				try{
				lasttradeValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_CLOSE"));
				if(lasttradeValue == "") lasttradeValue = "N/A";
				}
				catch(e){lasttradeValue = "N/A";}
				detailsHeadersArray[0] = "NAV";
				detailsArray[0] = lasttradeValue;
			
				try{
				changeValue = getNodeValue(doc.getElementsByTagName("NAV_NETCHG"));
				if(changeValue == "") changeValue = "N/A";
				}
				catch(e){changeValue = "N/A";}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
				pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
				if(pctchangeValue == "") pctchangeValue = "N/A";
				}
				catch(e){pctchangeValue = "N/A";}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
				bidValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_PREV_CLOSE"));
				if(bidValue == "") bidValue = "N/A";
				}
				catch(e){bidValue = "N/A";}
				detailsHeadersArray[3] = "Previous NAV";
				detailsArray[3] = bidValue;
			
				try{
				bidSizeValue = getNodeValue(doc.getElementsByTagName("NAV_PREV_CLOSE_DATE"));
				if(bidSizeValue == "") bidSizeValue = "N/A";
				}
				catch(e){bidSizeValue = "N/A";}
				detailsHeadersArray[4] = "Previous NAV Date";
				detailsArray[4] = bidSizeValue;
			
				try{
				askSizeValue = getNodeValue(doc.getElementsByTagName("MUT_30_DAY_SEC_YIELD"));
				if(askSizeValue == "") askSizeValue = "N/A";
				}
				catch(e){askSizeValue = "N/A";}
				detailsHeadersArray[5] = "30-Day Yield %";
				detailsArray[5] = askSizeValue;
			
				try{
				openValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_OFFER"));
				if (openValue == "") openValue = "N/A";
				}
				catch(e){openValue = "N/A";}
				detailsHeadersArray[6] = "Offer Price (POP)";
				detailsArray[6] = openValue;
			
				try{
				volumeValue = getNodeValue(doc.getElementsByTagName("LOAD_PERCENT"));
				if (volumeValue == "") volumeValue = "N/A";
				}
				catch(e){volumeValue = "N/A";}
				detailsHeadersArray[7] = "Load %";
				detailsArray[7] = volumeValue;
			
				try{
				dayHighValue = getNodeValue(doc.getElementsByTagName("FUND_NUMBER"));
				if (dayHighValue == "") dayHighValue = "N/A";
				}
				catch(e){dayHighValue = "N/A";}
				detailsHeadersArray[8] = "Fund Number";
				detailsArray[8] = dayHighValue;
				break;
			case "SelectFund":
				try{
				lasttradeValue = getNodeValue(doc.getElementsByTagName("SELECT_LATESTNAV"));
				if(lasttradeValue == "") lasttradeValue = "N/A";
				}
				catch(e){lasttradeValue = "N/A";}
				detailsHeadersArray[0] = "NAV";
				detailsArray[0] = lasttradeValue;
			
				try{
				changeValue = getNodeValue(doc.getElementsByTagName("SELECT_LATESTCHG"));
				if(changeValue == "") changeValue = "N/A";
				}
				catch(e){changeValue = "N/A";}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
				pctchangeValue = getNodeValue(doc.getElementsByTagName("SELECT_LATESTPCTCHG"));
				if(pctchangeValue == "") pctchangeValue = "N/A";
				}
				catch(e){pctchangeValue = "N/A";}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
				bidValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_CLOSE"));
				if(bidValue == "") bidValue = "N/A";
				}
				catch(e){bidValue = "N/A";}
				detailsHeadersArray[3] = "Previous NAV";
				detailsArray[3] = bidValue;
			
				try{
				bidSizeValue = getNodeValue(doc.getElementsByTagName("NAV_DATE"));
				if(bidSizeValue == "") bidSizeValue = "N/A";
				}
				catch(e){bidSizeValue = "N/A";}
				detailsHeadersArray[4] = "Previous NAV Date";
				detailsArray[4] = bidSizeValue;
			
				try{
				openValue = getNodeValue(doc.getElementsByTagName("SELECT_LATESTPOP"));
				if (openValue == "") openValue = "N/A";
				}
				catch(e){openValue = "N/A";}
				detailsHeadersArray[5] = "Offer Price (POP)";
				detailsArray[5] = openValue;
			
				try{
				volumeValue = getNodeValue(doc.getElementsByTagName("LOAD_PERCENT"));
				if (volumeValue == "") volumeValue = "N/A";
				}
				catch(e){volumeValue = "N/A";}
				detailsHeadersArray[6] = "Load %";
				detailsArray[6] = volumeValue;
			
				try{
				dayHighValue = getNodeValue(doc.getElementsByTagName("FUND_NUMBER"));
				if (dayHighValue == "") dayHighValue = "N/A";
				}
				catch(e){dayHighValue = "N/A";}
				detailsHeadersArray[7] = "Fund Number";
				detailsArray[7] = dayHighValue;
				break;
			case "MoneyMarket":
				try{
				lasttradeValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_CLOSE"));
				if(lasttradeValue == "") lasttradeValue = "N/A";
				}
				catch(e){lasttradeValue = "N/A";}
				detailsHeadersArray[0] = "NAV";
				detailsArray[0] = lasttradeValue;
			
				try{
				bidSizeValue = getNodeValue(doc.getElementsByTagName("YIELD_7_DAY"));
				if(bidSizeValue == "") bidSizeValue = "N/A";
				}
				catch(e){bidSizeValue = "N/A";}
				detailsHeadersArray[1] = "7-Day Yield";
				detailsArray[1] = bidSizeValue;
			
				try{
				changeValue = getNodeValue(doc.getElementsByTagName("NAV_NETCHG"));
				if(changeValue == "") changeValue = "N/A";
				}
				catch(e){changeValue = "N/A";}
				detailsHeadersArray[2] = "Change";
				detailsArray[2] = changeValue;
			
				try{
				pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
				if(pctchangeValue == "") pctchangeValue = "N/A";
				}
				catch(e){pctchangeValue = "N/A";}
				detailsHeadersArray[3] = "% Change";
				detailsArray[3] = pctchangeValue;
			
				try{
				bidValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_PREV_CLOSE"));
				if(bidValue == "") bidValue = "N/A";
				}
				catch(e){bidValue = "N/A";}
				detailsHeadersArray[4] = "Previous NAV";
				detailsArray[4] = bidValue;
			
				try{
				openValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_OFFER"));
				if (openValue == "") openValue = "N/A";
				}
				catch(e){openValue = "N/A";}
				detailsHeadersArray[5] = "Offer Price (POP)";
				detailsArray[5] = openValue;
			
				try{
				dayHighValue = getNodeValue(doc.getElementsByTagName("FUND_NUMBER"));
				if (dayHighValue == "") dayHighValue = "N/A";
				}
				catch(e){dayHighValue = "N/A";}
				detailsHeadersArray[6] = "Fund Number";
				detailsArray[6] = dayHighValue;
				break;
				case "Annuity" :
				try{
				lasttradeValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_CLOSE"));
				if(lasttradeValue == "") lasttradeValue = "N/A";
				}
				catch(e){lasttradeValue = "N/A";}
				detailsHeadersArray[0] = "Daily Unit Value";
				detailsArray[0] = lasttradeValue;
			
				try{
				changeValue = getNodeValue(doc.getElementsByTagName("NAV_NETCHG"));
				if(changeValue == "") changeValue = "N/A";
				}
				catch(e){changeValue = "N/A";}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
				pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
				if(pctchangeValue == "") pctchangeValue = "N/A";
				}
				catch(e){pctchangeValue = "N/A";}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
				prevCloseValue = getNodeValue(doc.getElementsByTagName("NAV_PRICE_PREV_CLOSE"));
				if (prevCloseValue == "") prevCloseValue = "N/A";
				}
				catch(e){prevCloseValue = "N/A";}
				detailsHeadersArray[3] = "Prev. Daily Unit";
				detailsArray[3] = prevCloseValue;
				detailsHeadersArray[4] = "Value";
				detailsArray[4] = "";
			
				try{
				prevCloseDateValue = getNodeValue(doc.getElementsByTagName("NAV_PREV_CLOSE_DATE"));
				if (prevCloseDateValue == "") prevCloseDateValue = "N/A";
				}
				catch(e){prevCloseDateValue = "N/A";}
				detailsHeadersArray[5] = "Prev. Daily Unit";
				detailsArray[5] = prevCloseDateValue;
				detailsHeadersArray[6] = "Value Date";
				detailsArray[6] = "";
				break;
			default :
				try{
				lasttradeValue = getNodeValue(doc.getElementsByTagName("LAST_PRICE"));
				if(lasttradeValue == "") lasttradeValue = "N/A";
				}
				catch(e){lasttradeValue = "N/A";}
				detailsHeadersArray[0] = "Last [Tick]";
				detailsArray[0] = lasttradeValue;
			
				try{
				changeValue = getNodeValue(doc.getElementsByTagName("NETCHG_TODAY"));
				if(changeValue == "") changeValue = "N/A";
				}
				catch(e){changeValue = "N/A";}
				detailsHeadersArray[1] = "Change";
				detailsArray[1] = changeValue;
			
				try{
				pctchangeValue = getNodeValue(doc.getElementsByTagName("PCT_CHG_TODAY"));
				if(pctchangeValue == "") pctchangeValue = "N/A";
				}
				catch(e){pctchangeValue = "N/A";}
				detailsHeadersArray[2] = "% Change";
				detailsArray[2] = pctchangeValue;
			
				try{
				bidValue = getNodeValue(doc.getElementsByTagName("BID_PRICE"));
				if(bidValue == "") bidValue = "N/A";
				}
				catch(e){bidValue = "N/A";}
				detailsHeadersArray[3] = "Bid";
				detailsArray[3] = bidValue;
			
				try{
				bidSizeValue = getNodeValue(doc.getElementsByTagName("BID_SIZE "));
				if(bidSizeValue == "") bidSizeValue = "N/A";
				}
				catch(e){bidSizeValue = "N/A";}
				detailsHeadersArray[4] = "Bid Size";
				detailsArray[4] = bidSizeValue;
			
				try{
				askValue = getNodeValue(doc.getElementsByTagName("ASK_PRICE"));
				if(askValue == "") askValue = "N/A";
				}
				catch(e){askValue = "N/A";}
				detailsHeadersArray[5] = "Ask";
				detailsArray[5] = askValue;
			
				try{
				askSizeValue = getNodeValue(doc.getElementsByTagName("ASK_SIZE"));
				if(askSizeValue == "") askSizeValue = "N/A";
				}
				catch(e){askSizeValue = "N/A";}
				detailsHeadersArray[6] = "Ask Size";
				detailsArray[6] = askSizeValue;
			
				try{
				openValue = getNodeValue(doc.getElementsByTagName("OPEN_PRICE"));
				if (openValue == "") openValue = "N/A";
				}
				catch(e){openValue = "N/A";}
				detailsHeadersArray[7] = "Open";
				detailsArray[7] = openValue;
			
				try{
				volumeValue = getNodeValue(doc.getElementsByTagName("VOLUME"));
				if (volumeValue == "") volumeValue = "N/A";
				}
				catch(e){volumeValue = "N/A";}
				detailsHeadersArray[8] = "Volume";
				detailsArray[8] = volumeValue;
			
				try{
				dayHighValue = getNodeValue(doc.getElementsByTagName("DAY_HIGH"));
				if (dayHighValue == "") dayHighValue = "N/A";
				}
				catch(e){dayHighValue = "N/A";}
				detailsHeadersArray[9] = "Day High";
				detailsArray[9] = dayHighValue;
			
				try{
				dayLowValue = getNodeValue(doc.getElementsByTagName("DAY_LOW"));
				if (dayLowValue == "") dayLowValue = "N/A";
				}
				catch(e){dayLowValue = "N/A";}
				detailsHeadersArray[10] = "Day Low";
				detailsArray[10] = dayLowValue;
			
				try{
				prevCloseValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_PRICE"));
				if (prevCloseValue == "") prevCloseValue = "N/A";
				}
				catch(e){prevCloseValue = "N/A";}
				detailsHeadersArray[11] = "Previous Close";
				detailsArray[11] = prevCloseValue;
			
				try{
				prevCloseDateValue = getNodeValue(doc.getElementsByTagName("PREV_CLOSE_DATE"));
				if (prevCloseDateValue == "") prevCloseDateValue = "N/A";
				}
				catch(e){prevCloseDateValue = "N/A";}
				detailsHeadersArray[12] = "Prev. Close Date";
				detailsArray[12] = prevCloseDateValue;
				break;
		}

		while ( theDetails.length > 0 )
		{
			item = theDetails.pop(); 
			item.style.display = "none"; 
			delete item;
		}


		if(securityTypeValue == "NotAvailable")
		{
			createDetailsRow(0);
		}
		else
		{
			for (n = 0; n < detailsArray.length; n++)
			{
				createDetailsRow(n);
			}
		}
		
		var el = document.getElementById("details_contents");
		var nodeList = el.getElementsByTagName("a");
		
		if(nodeList.length > 0){
			// remove link b/c DOM is loaded once
			el.removeChild(nodeList[0]);
		}
		
		if(securityTypeValue == "MutualFund" || securityTypeValue == "Annuity")
		{			
			var link = document.createElement("a");
			link.setAttribute("href","javascript:widget.openURL(g_ResearchUrl + '/eresearch/goto/evaluate/snapshot.jhtml?symbols="+chosenSymbol+"')");
			link.setAttribute("target","_blank");
			link.setAttribute("class","performance_link");
			link.innerText = "View Performance Information";
			el.appendChild(link);
		}

		if (securityTypeValue == "MutualFund")
		{
			var n= detailsArray.length;
			var row = document.createElement('div');
			row.setAttribute("class", "details_mf_message_row");
			theDetails[n] = row;
		
			var span = document.createElement('span');
			span.setAttribute ("class", "details_mutual_fund_message");
			span.innerHTML = "Past performance is no guarantee<br />of future results. Yield will vary.";
			row.appendChild(span);
		
			document.getElementById('details_contents').appendChild (row);
		}

	}

	showTabsDone = true;

}


function createDetailsRow(n)
{
    var row = document.createElement('div');
    row.setAttribute("class", "details_row");
    theDetails[n] = row;

    var span = document.createElement('span');
    span.setAttribute ("class", "details_headers");
    span.innerText = detailsHeadersArray[n];
    row.appendChild(span);

    span = document.createElement('span');
    span.setAttribute ("class", "details_values");
    span.innerText = detailsArray[n];
    row.appendChild(span);

    document.getElementById('details_contents').appendChild (row);
}

function displayInfo()
{
    if(isMoving) 
    {
    	return;
	}
    chosenTab = "info";
    closePanel();
    if (isMinimized)
    {
    	maximizeWidget();
    }
    document.getElementById('info').style.display = 'block';
    movePanel();
}

function displayPref(){
    if(isMoving)
    {
    	return;
	}
    chosenTab = "pref";
    closePanel();
    if (isMinimized)
    {
    	maximizeWidget();
    }
    document.getElementById('pref').style.display = 'block';
    movePanel();
}

function changePref(prefValue)
{
    panelPref = prefValue;
    widget.setPreferenceForKey(prefValue,"panelPreference");
    updateBoard();
}

function checkUpdate(){
    var xml_request = new XMLHttpRequest();
    xml_request.onload = function(e) {
    	widgetUpdateReceived(e, xml_request);
    }
    xml_request.overrideMimeType("text/xml");
    xml_request.open("GET", g_UpdateUrl);
    debug("url=" + g_UpdateUrl);
    xml_request.setRequestHeader("Cache-Control", "no-cache");
    xml_request.send(null);
}

function widgetUpdateReceived(event, request)
{
    var doc;
    var resultNodes;

    if (!request.responseXML)
    {
		document.getElementById("Fidelity_MarketMonitor_Update").style.display = "none";
		checkAllow();
		return 1;
    }

    try
    {
		doc = request.responseXML;
		resultNodes =doc.getElementsByTagName("FidelityMarketMonitor");
    }
    catch( e )
    {
		document.getElementById("Fidelity_MarketMonitor_Update").style.display = "none";
		checkAllow();
		return 1;
    }

    debug("widgetUpdateReceived: resultNodes=" + resultNodes);

    if (resultNodes != null)
    {
	updateVersion = getNodeValue(doc.getElementsByTagName("version"));
	updateMandatory = getNodeValue(doc.getElementsByTagName("mandatory"))
	updateMessage = getNodeValue(doc.getElementsByTagName("message"))
	updateUrl = getNodeValue(doc.getElementsByTagName("url"))
	document.getElementById("update_message").innerText = updateMessage;

	if (updateVersion > version){
	    updatePreference = widget.preferenceForKey ("updatePreference");
	    if (!(updatePreference && updatePreference > 0)) panelPref = 0;
	    document.getElementById("prefs_no_update").src = 'Images/prefs_update_available.png';
	    document.getElementById("prefs_no_update").setAttribute ("onclick", "widget.openURL('" + updateUrl + "')");
	    if (updatePreference == 1 || updateMandatory == 1) document.getElementById("Fidelity_MarketMonitor_Update").style.display = "block";
	}
	else{
	    document.getElementById("Fidelity_MarketMonitor_Update").style.display = "none";
	    document.getElementById("prefs_no_update").src = 'Images/prefs_no_update.png'
	    checkAllow();
	    //return 1;
	    }

	}
    else{
	document.getElementById("Fidelity_MarketMonitor_Update").style.display = "none";
	checkAllow();
    }
}


function download(){
    widget.setPreferenceForKey(1,"updatePreference");
    document.getElementById('Fidelity_MarketMonitor_Update').style.display= "none";
    widget.openURL(updateUrl)
}

function cancel(){
    widget.setPreferenceForKey(0,"updatePreference");
    document.getElementById('Fidelity_MarketMonitor_Update').style.display= "none";
    checkAllow();
}

